### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 3
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# ##### END GPL LICENSE BLOCK #####

bl_info = {
    "name": "NP Base Panel 001",
    "author": "Okavango, BA Community",
    "version": (0, 0, 1),
    "blender": (2, 75, 0),
    "warning": "",
    "description": "Main panel for NP utilities",
    "wiki_url": "",
    "category": "3D View"}

import bpy


class NPBasePanel(bpy.types.Panel):
    """Creates a panel in the 3d view Toolshelf window"""
    bl_label = "NP"
    bl_idname = "NP_PT_base_panel"
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'TOOLS'
    bl_context = "objectmode"
    bl_category = "NP"

    def draw(self, context):
        layout = self.layout
        
        row = layout.row()
        row.operator("np.float_box_007", icon='MESH_CUBE', text='float_box')
        
        row = layout.row()
        row.operator("np.float_tube_007", icon='MESH_CYLINDER', text='float_tube')
        
        row = layout.row()
        row.operator("np.float_cone_007", icon='MESH_CONE', text='float_cone')
        
        row = layout.row()
        row.operator("np.shader_brush_002", icon='BRUSH_DATA', text='shader_brush')        

def register():
    bpy.utils.register_class(NPBasePanel)


def unregister():
    bpy.utils.unregister_class(NPBasePanel)

if __name__ == "__main__":
    register()
