
# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

# Many thanks to Blender Artists, Mano Wii and Elegant Artz.

bl_info = {
  'name':'NP Shader Brush 002',
  'author':'Okavango and the ba community',
  'version':(0,0,2),
  'blender':(2,75,0),
  'location':'View3D',
  'description':'Transfer materials in 3D View',
  'category':'3D View'}

import bpy
import mathutils, bmesh, math
from math import sin, cos, tan, atan, degrees, radians, asin, acos
import bgl
import blf
from mathutils import Vector, Matrix
from bpy_extras import view3d_utils


# Defining the first graphical set that will be shown during first phase and updated along:    
def draw_callback1_px(self, context):    
    print('trail'+ str(len(self.trail)))
        
    # Calculating the 3d points where cursor ray hits the ground:
    mode = self.mode
    print('mode:', mode)    
    region = self.region
    print('region', region)
    rv3d = self.rv3d
    print('rv3d', rv3d)
    co2d = self.co2d
    print('self.co2d', co2d)
    co3d = 1  
    view_vector = view3d_utils.region_2d_to_vector_3d(region, rv3d, co2d)
    print('view_vector', view_vector)
    ray_origin = view3d_utils.region_2d_to_origin_3d(region, rv3d, co2d)
    print('ray_origin', ray_origin)
    ray_target = ray_origin + view_vector * 1000
    print('ray_target', ray_target)
    center = Vector((0,0,0))
    normal = Vector((0.0, 0.0, 1.0))   
    scenecast = context.scene.ray_cast(ray_origin, ray_target)
    print('scenecast', scenecast)
    hitob = scenecast[1]
    print('hitob', hitob)    
    
    # Storring the 3d points: 
    if self.mode == 1:
        self.trail.append((co3d))
        print('1')
    if self.mode == 2:
        self.points.append((co3d))
        print('2')        
    # Correcting some persistent mistake that appears, for which i don't know the reason: 
    if len(self.points) > 1:
        a = [(0,0,0)]
        a[0] = self.points[0]
        self.points = a
        print('oops!')

    if mode == 4:
        if hitob is not None:
            acob = bpy.context.scene.objects.active
            bpy.context.scene.objects.active = hitob           
            slots = hitob.material_slots
            for i, s in enumerate(slots):
                hitob.active_material_index = i
                bpy.ops.object.material_slot_remove()
            if self.shader is not None:
                hitob.data.materials.append(self.shader)
            print(hitob.select)
            if hitob.select == True:
                print('true')
                for ob in self.selob:
                    bpy.context.scene.objects.active = ob
                    slots = ob.material_slots
                    for i, s in enumerate(slots):
                        ob.active_material_index = i
                        bpy.ops.object.material_slot_remove()
                    if self.shader is not None:
                        ob.data.materials.append(self.shader)
            bpy.context.scene.objects.active = acob                               
            #bpy.context.scene.update()
            print('040')
           
    elif mode == 5:
        if hitob is not None:
            mat = None 
            matrix = hitob.matrix_world.copy()
            matrix_inv = matrix.inverted()
            ray_origin_obj = matrix_inv * ray_origin
            ray_target_obj = matrix_inv * ray_target        
            obcast = hitob.ray_cast(ray_origin_obj, ray_target_obj)
            print('obcast', obcast)
            findex = obcast[2]
            print('findex', findex)
            me = hitob.data
            print('me', me)
            bme = bmesh.new()
            bme.from_mesh(me)
            bme.faces.ensure_lookup_table()
            print('faces', bme.faces)
            print('face', bme.faces[findex])
            bmeface = bme.faces[findex]
            matindex = bmeface.material_index
            print('material_index', matindex)
            slots = list(hitob.material_slots)
            print('slots', slots)
            print('len slots', len(slots))
            print('slots',slots)
            if len(slots) == 0:
                self.shader = None
                self.shadername = 'None'	      
            elif slots[matindex].material is not None: 
                self.shader = slots[matindex].material
                self.shadername = slots[matindex].material.name
            else: 
                self.shader = None
                self.shadername = 'None'
            bpy.context.scene.objects.active = hitob            
            hitob.active_material_index = matindex    
            print('self.shader', self.shader)
            print('050')
        else:
            self.shader = None
            self.shadername = 'None'            
            
    elif mode == 7:
        if hitob is not None:
            acob = bpy.context.scene.objects.active
            bpy.context.scene.objects.active = hitob
            matrix = hitob.matrix_world.copy()
            matrix_inv = matrix.inverted()
            ray_origin_obj = matrix_inv * ray_origin
            ray_target_obj = matrix_inv * ray_target        
            obcast = hitob.ray_cast(ray_origin_obj, ray_target_obj)
            print('obcast', obcast)
            findex = obcast[2]
            print('findex', findex)
            me = hitob.data
            print('me', me)
            bpy.ops.object.mode_set(mode = 'EDIT')
            bme = bmesh.from_edit_mesh(me)
            bme.faces.ensure_lookup_table()
            print('faces', bme.faces)
            print('face', bme.faces[findex])
            bmeface = bme.faces[findex]            
            slots = list(hitob.material_slots)
            print('slots', list(slots))
            m = 0
            if list(slots) == []:
                hitob.data.materials.append(None)
            slots = list(hitob.material_slots)
            for i, s in enumerate(slots):
                print('s', s)
                if s.name == self.shadername:
                    m = 1
                    matindex = i
                elif s.material == None and self.shader == None:
                    m = 1
                    matindex = i
            if m == 0:           
                hitob.data.materials.append(self.shader)
                matindex = len(slots) - 1
            hitob.active_material_index = matindex
            bpy.context.tool_settings.mesh_select_mode = False, False, True
            bpy.ops.mesh.select_all(action = 'DESELECT')
            bmeface.select = True
            bmesh.update_edit_mesh(me, True)
            bpy.ops.object.material_slot_assign()
            bpy.ops.mesh.select_all(action = 'DESELECT')
            bpy.ops.object.mode_set(mode = 'OBJECT')
            bpy.context.scene.objects.active = acob
                        
    # Drawing the small icon near the cursor and the shader name:
    # First color is for lighter themes, second for default and darker themes:        
    if mode in {1,2,5,6}:
        cur = [[17, 36], [18, 35], [14, 31], [14, 30], [15, 30], [19, 34], [18, 35], [20, 37], [21, 37], [21, 36], [19, 34], [20, 33]]
        curpipe = [[18, 35], [14, 31], [14, 30], [15, 30], [19, 34], [18, 35]]
        curcap = [[18, 35], [20, 37], [21, 37], [21, 36], [19, 34], [18, 35]]    
        scale = 2.8
        for co in cur:    
            co[0] = round((co[0] * scale),0) -25 + co2d[0]
            co[1] = round((co[1] * scale),0) -90 + co2d[1]
        for co in curcap:    
            co[0] = round((co[0] * scale),0) -25 + co2d[0]
            co[1] = round((co[1] * scale),0) -90 + co2d[1]
        for co in curpipe:    
            co[0] = round((co[0] * scale),0) -25 + co2d[0]
            co[1] = round((co[1] * scale),0) -90 + co2d[1]                        
        #bgl.glColor4f(1.0, 1.0, 1.0, 1.0)
        bgl.glColor4f(1.0, 1.0, 1.0, 0.8)                    
        bgl.glBegin(bgl.GL_LINE_STRIP) 
        for x,y in cur:
            bgl.glVertex2f(x,y)
        bgl.glEnd()
        if mode in {2, 6}:
            bgl.glColor4f(1.0, 0.5, 0.5, 1.0)
        bgl.glBegin(bgl.GL_TRIANGLE_FAN)
        for x,y in curcap:
            bgl.glVertex2f(x,y)
        bgl.glEnd()        
             
    else:
        cur = [[18, 30], [21, 33], [18, 36], [14, 32], [16, 32], [18, 30]]
        curtip = [[14, 32], [16, 32], [15, 33], [14, 32]]
        curbag = [[18, 30], [15, 33], [21, 33], [18, 30]] 
        scale = 2.8       
        for co in cur:    
            co[0] = round((co[0] * scale),0) -25 + co2d[0]
            co[1] = round((co[1] * scale),0) -90 + co2d[1]
        for co in curtip:    
            co[0] = round((co[0] * scale),0) -25 + co2d[0]
            co[1] = round((co[1] * scale),0) -90 + co2d[1]
        for co in curbag:    
            co[0] = round((co[0] * scale),0) -25 + co2d[0]
            co[1] = round((co[1] * scale),0) -90 + co2d[1]            
        #bgl.glColor4f(1.0, 1.0, 1.0, 1.0)
        bgl.glColor4f(1.0, 1.0, 1.0, 0.8)                     
        bgl.glBegin(bgl.GL_LINE_STRIP) 
        for x,y in cur:
            bgl.glVertex2f(x,y)
        bgl.glEnd()
        if mode in {3, 7}:
            bgl.glBegin(bgl.GL_TRIANGLE_FAN)
            for x,y in curtip:
                bgl.glVertex2f(x,y)
            bgl.glEnd()
            bgl.glLineWidth(2)
            bgl.glBegin(bgl.GL_LINE_STRIP)
            for x,y in curtip:
                bgl.glVertex2f(x,y)
            bgl.glEnd()
            bgl.glLineWidth(1)
        if self.shader is not None:
            bgl.glBegin(bgl.GL_TRIANGLE_FAN)
            for x,y in curbag:
                bgl.glVertex2f(x,y)
            bgl.glEnd()
    
    bgl.glColor4f(1.0, 1.0, 1.0, 0.8)   
    font_id = 0
    blf.size(font_id, 15, 72)
    blf.position(font_id, co2d[0] + 42, co2d[1] - 7, 0)
    blf.draw(font_id, self.shadername)       
                         
    # restore opengl defaults
    bgl.glLineWidth(1)
    bgl.glDisable(bgl.GL_BLEND)
    bgl.glColor4f(0.0, 0.0, 0.0, 1.0)

# Defining the operator that will use the graphical sets and make the drawing of the base:
class NPShaderBrush002(bpy.types.Operator):
    bl_idname = "np.shader_brush_002"
    bl_label = "NP Shader Brush 002"
    bl_options={'REGISTER','UNDO'}     

    def modal(self, context, event):
        context.area.tag_redraw()

        if not event.ctrl and not event.shift and not event.alt and event.type == 'MOUSEMOVE':
            self.mode = 0
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.type == 'MOUSEMOVE':
            self.mode = 1
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.shift and event.type == 'MOUSEMOVE':
            self.mode = 2
            self.co2d = ((event.mouse_region_x, event.mouse_region_y)) 
            
        if event.alt and event.type == 'MOUSEMOVE':
            self.mode = 3
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))                                     
            
        if event.type == 'LEFT_CTRL' and event.value == 'PRESS':
            self.mode = 1
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.shift and event.type == 'LEFT_CTRL' and event.value == 'PRESS':
            self.mode = 2
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))            
            
        if event.type == 'LEFT_CTRL' and event.value == 'RELEASE':
            self.mode = 0
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))            
            
        if event.type == 'LEFT_SHIFT' and event.value == 'PRESS' and self.mode == 1:
            self.mode = 2
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.type == 'LEFT_SHIFT' and event.value == 'RELEASE':
            self.mode = 1
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))            
            
        if event.type == 'LEFT_CTRL' and event.type == 'LEFT_SHIFT' and event.value == 'RELEASE':
            self.mode = 0
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))                     
            
        if event.type == 'LEFT_ALT' and event.value == 'PRESS':
            self.mode = 3
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.type == 'LEFT_ALT' and event.value == 'RELEASE':
            self.mode = 0
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))                                                              
                        
        if event.type == 'LEFTMOUSE' and event.value == 'PRESS':                       
            self.mode = 4          
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.type == 'LEFTMOUSE' and event.value == 'PRESS':                       
            self.mode = 5         
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.shift and event.type == 'LEFTMOUSE' and event.value == 'PRESS':                       
            self.mode = 6         
            self.co2d = ((event.mouse_region_x, event.mouse_region_y)) 
            
        if event.alt and event.type == 'LEFTMOUSE' and event.value == 'PRESS':                       
            self.mode = 7        
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.type == 'LEFTMOUSE' and event.value == 'RELEASE':                       
            self.mode = 0          
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.type == 'LEFTMOUSE' and event.value == 'RELEASE':                       
            self.mode = 1        
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        if event.ctrl and event.shift and event.type == 'LEFTMOUSE' and event.value == 'RELEASE':                       
            self.mode = 2         
            self.co2d = ((event.mouse_region_x, event.mouse_region_y)) 
            
        if event.alt and event.type == 'LEFTMOUSE' and event.value == 'RELEASE':                       
            self.mode = 3       
            self.co2d = ((event.mouse_region_x, event.mouse_region_y))
            
        elif event.type == 'RIGHTMOUSE':
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW')
            return {'FINISHED'}
        
        elif event.type == 'ESC':
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW')
            return {'CANCELLED'}        
        
        elif event.type in {'MIDDLEMOUSE', 'WHEELUPMOUSE', 'WHEELDOWNMOUSE'}:
            return {'PASS_THROUGH'}

        return {'RUNNING_MODAL'}

    def invoke(self, context, event):
        if context.area.type == 'VIEW_3D':
            args = (self, context)
            self._handle = bpy.types.SpaceView3D.draw_handler_add(draw_callback1_px, args, 'WINDOW', 'POST_PIXEL')


              
            self.region = bpy.context.region 
            self.rv3d = bpy.context.region_data
            
            ob = bpy.context.active_object
            if ob is not None and ob.active_material is not None:
                self.shader = ob.active_material            
                self.shadername = ob.active_material.name
            else:
                self.shader = None
                self.shadername = 'None'  
            self.selob = bpy.context.selected_objects
            
            self.trail2d = []
            self.trail = []            
            self.points2d = []
            self.points = []
            self.up2d = []       
            
            context.window_manager.modal_handler_add(self)
            return {'RUNNING_MODAL'}
        else:
            self.report({'WARNING'}, "View3D not found, cannot run operator")
            return {'CANCELLED'}
        
       

def register():
    bpy.utils.register_class(NPShaderBrush002)


def unregister():
    bpy.utils.unregister_class(NPShaderBrush002)

if __name__ == "__main__":
    register()